%define cleanbuildroot 0
%define with_doc 0

%define bypass_config 0
%define bypass_compile 0

%if %{bypass_compile}
%define bypass_config 1
%endif


%define libpqver 3
%define libecpgver 3.4

Name: postgresql
Version: 7.3.1
Release: 1.2.0
Summary: PostgreSQL server.
Group: Databases
License: BSD
Source0: ftp://ftp.postgresql.org/pub/v%{version}/%{name}-%{version}.tar.gz
Source1: logrotate.%{name}-7.1
Source2: %{name}.init
Source3: pg_options-7.1
Source4: catalog
URL: http://www.postgresql.org/

Prereq: chkconfig 
PreReq: ldconfig 
PreReq: shadow-utils 

Obsoletes: %{name}-clients-X11
Obsoletes: %{name}-lib
Obsoletes: %{name}-lib-charset-plugin-addons

BuildRequires: glibc-devel
BuildRequires: glibc-devel-static

# force rebuild with openssl 0.9.7
BuildRequires: openssl-devel >= 0.9.7
BuildRequires: readline-devel
BuildRequires: ncurses-devel
BuildRequires: zlib-devel

Buildroot: %{_tmppath}/%{name}-%{version}-root

%description
Postgresql includes the programs needed to create and run a PostgreSQL
server, which will in turn allow you to create and maintain PostgreSQL
databases.  PostgreSQL is an advanced Object-Relational database
management system (DBMS) that supports almost all SQL constructs
(including transactions, subselects and user-defined types and
functions).

You should install postgresql if you want to create and maintain your
own PostgreSQL databases and/or your own PostgreSQL server.  If you
are installing postgresql, you should also install postgresql-data,
which will help you get started with PostgreSQL.

%if %{with_doc}
%package doc
Summary: PostgreSQL documentation
Group: Documentation
BuildRequires: task-docbook-sgml
BuildRequires: docbook-dtd31-sgml
BuildRequires: docbook-dtd41-sgml
BuildRequires: docbook-dtd412-xml
BuildRequires: openjade

%description doc
The postgreql-doc package contains documentation to postgresql.
There's a tutorial and documentation for admin, programmer, user
and more.

%endif

%package contrib
Summary: PostgreSQL contrib
Group: Documentation

%description contrib
The postgreql-contrib package contains documentation and samples contribs from postgresql users.

%package devel
Requires: postgresql-clients
Summary: PostgreSQL development header files and libraries.
Group: Development
Conflicts: %{name}-perl < 7.1.2-4cl
PreReq: %{name} = %{version}-%{release}
Requires: %{name}-libpq%{libpqver}
Requires: %{name}-libecpg%{libecpgver}

%description devel
This package contains the header files and libraries needed to
compile applications which will directly interact with a PostgreSQL
server.

Install this package if you want to develop applications which will
interact with a PostgreSQL server.

%package devel-static
Summary: PostgreSQL static libraries.
Summary(pt_BR): Bibliotecas estticas PostgreSQL
Summary(es): Bibliotecas estaticas PostgreSQL
Group: Development
Group(pt_BR): Desenvolvimento
Group(es): Desarrollo
Requires: %{name}-devel = %{version}-%{release}

%description devel-static
This package contains the static libraries needed to
compile applications which will directly interact with a PostgreSQL
server.

Install this package if you want to develop applications which will
interact with a PostgreSQL server and need static libraries.

%package libpq%{libpqver}
Summary: PostgreSQL shared library
Group: Libraries

%description libpq%{libpqver}
This package contains the shared library needed by other programs.

%package libecpg%{libecpgver}
Summary: PostgreSQL shared library
Group: Libraries

%description libecpg%{libecpgver}
This package contains the shared library needed by other programs.

%package charset-addons
Summary: PostgreSQL shared library
Group: Libraries

%description charset-addons
This package contains the shared library needed by other programs.

%package clients
Summary: The client programs needed for accessing a PostgreSQL server.
Summary(pt_BR): Clientes necessrios para acessar o servidor PostgreSQL
Summary(es): Clientes necesarios para acceder al servidor PostgreSQL
Group: Databases
Group(pt_BR): Bancos de Dados
Group(es): Bancos de Datos

%description clients
This package includes only the clients needed to access
a PostgreSQL server. The server is included in the main package. If all you
need is to connect to another PostgreSQL server, then this is the package
you need to install together with postgresql-lib.

In this package there are client libraries available for C, C++ and PERL, as
well as several command-line utilities you can use to manage your databases
on a remote PostgreSQL server.

%package perl
Summary: The perl-based client programs needed for accessing a PostgreSQL server.
Group: Databases
BuildRequires: perl-devel 
PreReq: perl >= 5.004-4

%description perl
postgresql-perl includes the perl-based client programs and client libraries
that you'll need to access a PostgreSQL database management system
server.

%package test
Summary: The test suite distributed with PostgreSQL.
Summary(pt_BR): Programas de teste distribudos com o PostgreSQL.
Summary(es): Batera de pruebas para el servidor PostgreSQL.
Prereq: postgresql
Group: Databases
Group(pt_BR): Bancos de Dados
Group(es): Bancos de Datos
AutoProv: no

%description test
postgresql-test includes the source and pre-built binaries of the various tests
included with PostgreSQL, such as the regression tests and benchmarks.

%prep
%if %{bypass_config}
%setup -q -n %{name}-%{version} -D -T
%else
%setup -q -n %{name}-%{version}

# this file is precompiled for x86
%ifnarch %{ix86}
rm contrib/spi/preprocessor/step1.e
%endif

cp %{SOURCE4} %{_builddir}/%{name}-%{version}

# Added docbook package stylesheets dir to fix lack of documentation
export DOCBOOKSTYLE=%{_builddir}/%{name}-%{version}
export DOCBOOKINDEX=%{_bindir}/collateindex.pl

./configure \
	--prefix=%{_usr} \
	--mandir=%{_mandir} \
	--includedir=%{_includedir}/postgresql\
	--datadir=%{_localstatedir}/lib/pgsql \
	--sysconfdir=%{_localstatedir}/lib/pgsql \
	--docdir=%{_docdir} \
	--enable-locale \
	--enable-recode \
	--enable-multibyte \
	--enable-unicode-conversion \
	--enable-hba \
	--with-x \
	--with-perl \
	--with-openssl=%{_localstatedir}/ssl \
	--with-CXX \
	--enable-odbc \
	--enable-unixodbc \
	--enable-syslog \
	--enable-depend \
	--with-gnu-ld
%endif

%build
%if ! %{bypass_compile}
# Added docbook package stylesheets dir to fix lack of documentation
export DOCBOOKSTYLE=%{_builddir}/%{name}-%{version}
export DOCBOOKINDEX=%{_bindir}/collateindex.pl

make

# Pre build regression test
pushd src/test/regress
	make
popd

%if %{with_doc}
# Build documentation ( SGML ) - Slow, too slow
pushd doc/src
	make
popd 
%endif
%endif

%install

rm -rf %{buildroot}

make DESTDIR=%{buildroot} install
make DESTDIR=%{buildroot} install-all-headers

# Init file
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
install -m 755 %{_sourcedir}/postgresql.init %{buildroot}%{_sysconfdir}/rc.d/init.d/postgresql

# tests. Very preliminary.
cp -a src/test %{buildroot}%{_localstatedir}/lib/pgsql
install -m 0755 config/config.guess %{buildroot}%{_localstatedir}/lib/pgsql

# no +x in test dir...
chmod 0644 `find %{buildroot}%{_localstatedir}/lib/pgsql/test -type f`

%if %{with_doc}
# Documentation - Only HTML
mkdir -p %{buildroot}%{_docdir}/postgresql

pushd doc/src
	for name in *.tar.gz; do
		if [ $name = "postgres.tar.gz" ]; then
			pushd %{buildroot}%{_docdir}/postgresql
				tar xfz %{_builddir}/%{name}-%{version}/doc/src/$name;
			popd
		else
			SUBDIR=`echo $name |sed -e "s/.tar.gz//g"`
			pushd %{buildroot}%{_docdir}/postgresql
				mkdir $SUBDIR;
				pushd $SUBDIR
					tar xfz %{_builddir}/%{name}-%{version}/doc/src/$name;
				popd
			popd
		fi;
	done;
popd
%endif
			
%pre
useradd -M -o -r -d %{_localstatedir}/lib/pgsql -s /bin/bash \
	-c "PostgreSQL Server" postgres >/dev/null 2>&1 || :

if [ -d %{_localstatedir}/lib/pgsql ]; then
	if [ -f %{_localstatedir}/lib/pgsql/PG_VERSION ]; then
		grep -q "^7.*" %{_localstatedir}/lib/pgsql/PG_VERSION
		if [ "$?" != "0" ] ; then
			data=`date +%Y%m%d%H%M`
			echo "WARNING: Your old databases are at %{_localstatedir}/lib/pgsql$data.rpmsave"
			mv -f	%{_localstatedir}/lib/pgsql \
				%{_localstatedir}/lib/pgsql$data.rpmsave
		fi
	fi
fi

%postun devel
if [ "$1" = "0" ]; then
	# remove that symlink which is not part of this package
	rm -f %{_includedir}/pgsql
fi

%triggerpostun -- %{name}-devel <= 7.1.1-5cl
if [ "$1" -gt "0" ]; then
	cd %{_includedir}
	ln -sf postgresql pgsql
fi

%post devel
if [ "$1" = "1" ]; then
	# here we are installing for the first time
	# let's make the symlink
	# there should be nothing there with that name,
	# but, just to make sure...
	if [ ! -a %{_includedir}/pgsql ]; then
		cd %{_includedir}
		ln -sf postgresql pgsql
	fi
fi


%post libpq%{libpqver} -p /sbin/ldconfig
%postun libpq%{libpqver} -p /sbin/ldconfig

%post libecpg%{libecpgver} -p /sbin/ldconfig
%postun libecpg%{libecpgver} -p /sbin/ldconfig

%preun
if [ $1 = 0 ] ; then
	chkconfig --del postgresql
fi
%post -p /sbin/ldconfig
%postun
/sbin/ldconfig -n %{_libdir}
if [ $1 = 0 ] ; then
	userdel postgres >/dev/null 2>&1 || : 
fi

%clean
%if %{cleanbuildroot}
	rm -rf %{_builddir}/%{name}-%{version}
	rm -rf %{buildroot}
	rm -f perlfiles.list
%endif

%files
%defattr(-,root,root)
%doc COPYRIGHT README
%config %{_sysconfdir}/rc.d/init.d/postgresql
%{_bindir}/createdb
%{_bindir}/createlang
%{_bindir}/createuser
%{_bindir}/dropdb
%{_bindir}/droplang
%{_bindir}/dropuser
%{_bindir}/initdb
%{_bindir}/initlocation
%{_bindir}/ipcclean
%{_bindir}/pg_config
%{_bindir}/pg_ctl
%{_bindir}/pg_encoding
%{_bindir}/pg_restore
%{_bindir}/postgres
%{_bindir}/postmaster
%{_bindir}/vacuumdb
%{_bindir}/ecpg
%{_bindir}/clusterdb
%{_bindir}/pg_controldata
%{_bindir}/pg_resetxlog
%attr(0755,postgres,postgres) %dir %{_localstatedir}/lib/pgsql
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/postgres.bki
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/postgres.description
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/pg_hba.conf.sample
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/pg_ident.conf.sample
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/postgresql.conf.sample
%attr(0644,postgres,postgres) %{_localstatedir}/lib/pgsql/conversion_create.sql
%{_mandir}/man1/* 
%{_mandir}/man7/*
%dir %{_libdir}/postgresql
%defattr(0644,root,root)
%{_libdir}/postgresql/plpgsql.so
%{_libdir}/postgresql/ascii_and_mic.so
%{_libdir}/postgresql/latin2_and_win1250.so
%{_libdir}/postgresql/latin_and_mic.so
%{_libdir}/postgresql/utf8_and_ascii.so
%{_libdir}/postgresql/utf8_and_iso8859.so
%{_libdir}/postgresql/utf8_and_iso8859_1.so

%if %{with_doc}
%files doc
%defattr(0644,root,root,0755)
%doc COPYRIGHT
%doc README
%doc HISTORY
%dir %{_docdir}/postgresql
%{_docdir}/postgresql/*
%endif

%files contrib
%defattr(0644,root,root,0755)
%doc contrib/*

%files libecpg%{libecpgver}
%defattr(0644,root,root,0755)
%{_libdir}/libecpg.so.*

%files libpq%{libpqver}
%defattr(0644,root,root,0755)
%{_libdir}/libpq.so.*

%files charset-addons
%defattr(0644,root,root,0755)
%{_libdir}/postgresql/cyrillic_and_mic.so
%{_libdir}/postgresql/euc_cn_and_mic.so
%{_libdir}/postgresql/euc_jp_and_sjis.so
%{_libdir}/postgresql/euc_kr_and_mic.so
%{_libdir}/postgresql/euc_tw_and_big5.so
%{_libdir}/postgresql/utf8_and_big5.so
%{_libdir}/postgresql/utf8_and_cyrillic.so
%{_libdir}/postgresql/utf8_and_euc_cn.so
%{_libdir}/postgresql/utf8_and_euc_jp.so
%{_libdir}/postgresql/utf8_and_euc_kr.so
%{_libdir}/postgresql/utf8_and_euc_tw.so
%{_libdir}/postgresql/utf8_and_gb18030.so
%{_libdir}/postgresql/utf8_and_gbk.so
%{_libdir}/postgresql/utf8_and_johab.so
%{_libdir}/postgresql/utf8_and_sjis.so
%{_libdir}/postgresql/utf8_and_tcvn.so
%{_libdir}/postgresql/utf8_and_uhc.so
%{_libdir}/postgresql/utf8_and_win1250.so
%{_libdir}/postgresql/utf8_and_win1256.so
%{_libdir}/postgresql/utf8_and_win874.so

%files devel
%defattr(0644,root,root,0755)
%{_libdir}/lib*.so
%dir %{_includedir}/postgresql
%{_includedir}/postgresql/*

%files devel-static
%defattr(0644,root,root,0755)
%{_libdir}/lib*.a

%files perl
%defattr(0644,root,root,0755)
%{_libdir}/postgresql/plperl.so

%files clients
%defattr(0755,root,root,0755)
%{_bindir}/pg_dump
%{_bindir}/pg_dumpall
%{_bindir}/pg_id
%{_bindir}/psql
%defattr(0644,root,root,0755)

%files test
%defattr(0644,postgres,postgres,0755)
%attr(644,root,root) %{_localstatedir}/lib/pgsql/config.guess
%{_localstatedir}/lib/pgsql/test


%changelog
* Tue Jan 28 2003 Dave Wreski <dave@guardiandigital.com>
- Version 7.3.1, Release 1.2.0
   - initial EnGarde build

